; test RAM pro PP-01
; test probiha po bankach 16kB, vzdy zapis/test celeho bloku 0h-55h-AAh
; pri chybe se test zastavi a vypisou se, pres seriove TTL rozhrani, bity
; ve kterych byl rozdil ulozene/vyctene (XOR)
; seriova linka 9600/8n1 vyvedena na konektor K3
; 5V = 39/40, zem = 37/38 a TX = 10
; pozor na cislovani konektoru K3, nemel jsem protikus a na samici je to
; obracene, tedy z prava do leva - odpocitat
; v archivu 1kB bin do rom FF0(znaceno na pcb, 4-ta od konce) a 16kB pro
; 27256 jakozto sloucenych vsech 16 romek do jedne
; banka 0 - IC30(bit7) az IC37(bit0)
; banka 1 - IC22(bit7) az IC29(bit0)
; banka 2 - IC10(bit7) az IC17(bit0)
; banka 3 - IC2 (bit7) az IC9 (bit0)


	ORG	0F000H
START:	DI
	MVI	A,0FCH
	OUT	0ECH	;mmu Cxxx, FCH
	INR	A
	OUT	0EDH	;mmu Dxxx, FDH
	INR	A
	OUT	0EEH	;mmu Exxx, FEH
	INR	A
	OUT	0EFH	;mmu Fxxx, FFH
	OUT	0E0H	;mmu 0xxx, FFH
	OUT	0D8H	;mmu pripojeni
	JMP	MAIN
;
MAIN:
	MVI	A,082H
	OUT	0C3H	;8255 sluzobna
	MVI	A,092H
	OUT	0C7H	;8255 uzivatelska
	MVI	A,010H
	OUT	0C6H	;- "" -
	MVI	A,0F0H
	OUT	0D4H	;3214
	MVI	A,0B6H
	OUT	0D3H	;8253
	MVI	A,0D0H	;082H
	OUT	0D2H	;8253
	MVI	A,0	;6
	OUT	0D2H	;8253
	MVI	A,0
	OUT	0CCH	;RGB
;
	MVI	A,027H
	OUT	0C9H	;8251
	MVI	a,040H
	OUT	0C9H	;8251
	MVI	A,08DH
	OUT	0C9H	;8251
	MVI	C,03FH
	OUT	0C9H	;8251
	MVI	A,023H
	OUT	0C9H	;8251
;
	LXI	D,BNK0
	MVI	A,0E0H
L9:	OUT	0E0H
	INR	A
	OUT	0E1H
	INR	A
	OUT	0E2H
	INR	A
	OUT	0E3H
	LXI	H,L6
	JMP	PRNT
L6:	MVI	C,0H
L2:	LXI	H,0H
L1:	MOV	M,C
	INX	H
	MOV	A,H
	CPI	040H
	JNZ	L1
	MOV	H,L
L4:	MOV	A,M
	XRA	C
	JNZ	ERR
	INX	H
	MOV	A,H
	CPI	040H
	JNZ	L4
	MOV	A,C
	XRI	055h
	JZ	L5
	CPI	0FFH
	JZ	L8
	MOV	C,A
	JMP	L2
L5:	MVI	C,0AAh
	JMP	L2
L8:	LXI	H,L12
	JMP	PRNT
L12:	IN	0E3H
	CMA
	INR	A
	CPI	0F0H
	JZ	L7
	JMP	L9
ERR:	MVI	C,008H
	MOV	B,A
	LXI	D,BERR
	LXI	H,ERR1
	JMP	PRNT
ERR1:	IN	0C9H	;8251
	RRC
	JNC	ERR1
	MOV	A,B
	RLC
	MOV	B,A
	MVI	A,030H
	JNC	ERR2
	INR	A
ERR2:	OUT	0C8H	;8251
	DCR	C
	JNZ	ERR1
L7:	HLT

PRNT:	IN	0C9H	;8251
	RRC
	JNC	PRNT
	LDAX	D
	INX	D
	ANA	A
	JZ	PRNT1
	OUT	0C8H	;8251
	JMP	PRNT
PRNT1:	PCHL

BNK0	DB	"BANK 0 - ", 0, "OK", 00DH, 00AH, 0
	DB	"BANK 1 - ", 0, "OK", 00DH, 00AH, 0
	DB	"BANK 2 - ", 0, "OK", 00DH, 00AH, 0
	DB	"BANK 3 - ", 0, "OK", 00DH, 00AH, 0
BERR	DB	"ERR = 0B", 0

	END
